<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Datamodel extends CI_Model {

    function __construct()
    {
        parent::__construct();
        
        $this->load->database();
        $this->load->library('session');
        $this->load->library('ion_auth');
        
    }
	
	//insering frame in db table
	
	public function insertCategory($categoryName,$userID)
	{
		
		
		$data['select_head']=$categoryName;
		$data['user_id']=$userID;
		$this->db->insert('select_tags', $data);
		
		
		
	}
	public function insertNewOption($name,$url,$selectId,$userID)
	{
		$data['options_value']= $name;
		$data['user_id']= $userID;
		$data['option_url'] = $url;
		$data['select_tag_id'] = $selectId;
		
		$this->db->insert('custom_field', $data);		
	}	
	public function insertBlog($title,$content,$userID)
	{
		$data['title']= $title;
		$data['user_id']= $userID;
		$data['content'] = $content;
		
		
		$this->db->insert('custom_blogs', $data);		
	}	
	public function deleteSite($siteid)
	{
		
    		$this->db->where('id', $siteid);
    		$this->db->delete('custom_field');	
	}	
	public function deleteCategory($catid)
	{
		
    		$this->db->where('options_id', $catid);
    		$this->db->delete('select_tags');	
	}
	public function frameDetails($frameid)
	{
		
	 $this->db->from('frames');
     $this->db->where('frames_id',$frameid );
     
     
     $query = $this->db->get();
     
     $res = $query->result();
		$result=array();
		foreach($res as $frame)
		{
			$temp=array();
			$temp['framedata']=$frame;
			$result[]=$temp;
		}
		return $result;
	}
	//fetching all contestent
	public function fetchAllContestant($frameid)
	{
	 $u = $this->ion_auth->user()->row();
	$user_id = $u->id;
	$this->db->from('photo_contest');
    $this->db->where('frameid',$frameid);
    $this->db->where('userid',$user_id);	
	$query = $this->db->get();
     $res = $query->result();
		$result=array();
		foreach($res as $frame)
		{
			$temp=array();
			$temp['siteData']=$frame;
			$result[]=$temp;
		}
		return $result;	
		
	}
	//fetching all contestent
	public function fetchAllSweeps($frameid)
	{
	 $u = $this->ion_auth->user()->row();
	$user_id = $u->id;
	$this->db->from('optins');
    $this->db->where('frameid',$frameid);
    $this->db->where('userid',$user_id);	
	$query = $this->db->get();
     $res = $query->result();
		$result=array();
		foreach($res as $frame)
		{
			$temp=array();
			$temp['siteData']=$frame;
			$result[]=$temp;
		}
		return $result;	
		
	}	
	public function approveSelected($id)
	{

		$data['status']='Approved';
		$this->db->where('id', $id);
    	$this->db->update('photo_contest', $data);
	}
	// updating frame in db table
	
	public function updateFrame($page_name,$html,$user_id)
	{
		
		
		$data['frames_content']=$html;
		//$data['frame_name']=$page_name;
		$data['frames_timestamp']= time();
		//$data['user_id']= $user_id;
		
    	$this->db->where('frame_name', $page_name);
    	$this->db->where('user_id', $user_id);		
    	$this->db->update('frames', $data);
		
	}	
	
	//update frameLocalUrl
	
	public function updateFrameLocalUrl($frame_id,$localurl)
	{
		$data['frames_id']=$frame_id;
		$data['frames_local_url']=$localurl;
		$this->db->where('frames_id', $frame_id);
    		
    	$this->db->update('frames', $data);
	}
	
	public function insertCount($get_count,$get_id)
	{
		$data['visits']=$get_count;
		//$data['frame_name']=$page_name;
		//$data['frames_timestamp']= time();
		//$data['user_id']= $user_id;
		
    	$this->db->where('frames_id', $get_id);
    	//$this->db->where('user_id', $user_id);		
    	$this->db->update('frames', $data);
	}
	
	public function insert_logo_img($image_name,$path,$status,$userID){
		
		
		$data['user_id'] = $userID;
		$data['status']=$status;
		$data['image_name']=$image_name;
		$data['image_path']=$path;
		$this->db->insert('logo_images', $data);
	}
	public function display_logo_images(){
		$user = $this->ion_auth->user()->row();
    	$userID = $user->id;
		$status=1;
		$this->db->from('logo_images');
    	$this->db->where('user_id',$userID && 'status',$status);
    	
    	
    	$query = $this->db->get();
    	
    	$res = $query->result();
		
    	
		
		$image = array();//array holding all logo and associated data
		
		
		
		foreach( $res as $logo ) {
		
			$temp = array();
			
			$temp['logodata'] = $logo;
			
			$image [] = $temp;
		
		}
		
		return $image ;
	
	
	}
	
	public function all($forUserID = '')
	{
		   $user = $this->ion_auth->user()->row();
    		$userID = $user->id;
    
    	//if $forUserID is set, this means we're looking for the sites belonging to a specific user
    if( $forUserID == '' ) {
    
    		$user = $this->ion_auth->user()->row();
    		$userID = $user->id;
    
    		if( !$this->ion_auth->is_admin() ) {    		
    	
    			$this->db->where('user_id', $userID);
    	
    		}
    	
    	} else {
    	
    		$this->db->where('user_id', $forUserID);
    	
    	}
    	
    	$this->db->from('frames');
    	$this->db->where('user_id',$userID );
    	
    	
    	$query = $this->db->get();
    	
    	$res = $query->result();
		
    	
		
		$allSites = array();//array holding all sites and associated data
		
		
		
		foreach( $res as $site ) {
		
			$temp = array();
			
			$temp['siteData'] = $site;
			
			$allSites[] = $temp;
		
		}
		
		return $allSites;
		    
    }
    
		public function delete($frameid)
		{
		   $query = $this->db->from('frames')->where('frames_id', $frameid)->get();
    	   	
    	  $frames = $query->result();
    	
    	foreach( $frames as $page ) {
    	
    		//delete all frames 
    		
    		$this->db->where('frames_id', $frameid);
    		$this->db->delete('frames');
    		    		
		}
    	
    	}
	
		public function deleteAllSites($ids){
			$ids = $ids;
	   
       $count = 0;
        foreach ($ids as $id){
           $did = $id;
		   
            $this->db->where('frames_id', $did);
            $this->db->delete('frames');  
            $count = $count+1;
       }
       
        //echo'<div class="alert alert-success" style="margin-top:-17px;font-weight:bold">'.$count.' Item deleted successfully</div>';
        $count = 0;
	}
	
	//counting all records in db table	
	public function record_count() {
		 $user = $this->ion_auth->user()->row();
		 $userID = $user->id;
		return $this->db->join('users', 'frames.user_id = users.id')->where('users.id',$userID)->count_all_results("frames");
		
	}
	public function record_count_all(){
		
		$user = $this->ion_auth->user()->row();
		 $userID = $user->id;
		return $this->db->join('users', 'frames.user_id = users.id')->count_all_results("frames");
		
	}
	//fetching data from db table
	
	public function fetch_data($limit = '', $start = '' ) {
	 
	
    $user = $this->ion_auth->user()->row();
    $userID = $user->id;
	
	
	
   
	$this->db->from('frames');
	$this->db->join('users', 'frames.user_id = users.id');
	$this->db->where('users.id',$userID);
	 if ($limit !== '' && $start !== ''){
      $this->db->limit($limit,$start*$limit);
      //print($start*$limit);
      //exit;
     }
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}
	
	
	/**
	*
	
	fetching all data from frames table
	
	*/
	
	public function fetch_all_data() {
	$user = $this->ion_auth->user()->row();
    $userID = $user->id;
	
	$this->db->from('custom_field');
	
    $this->db->join('select_tags', 'custom_field.select_tag_id = select_tags.options_id');
	$this->db->where('custom_field.user_id',$userID);
	$query = $this->db->get();
	if ($query->num_rows() > 0) {
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}
	
	//searchin site 
	
	public function getSiteList($userID = '', $search = '',$limit='',$start='') {
	 
     $user = $this->ion_auth->user()->row();
     $userID = $user->id;
	 $this->db->from('frames')->where("frame_name like '%".$search."%' and user_id='".$userID."'")->join('users', 'frames.user_id = users.id');
	 if ($limit !== '' && $start !== ''){
      $this->db->limit($limit,$start*$limit);
      //print($start*$limit);
      //exit;
     }
	 $query=$this->db->get();
	
     $res = $query->result();
  
     
  
  $allSites = array();//array holding all sites and associated data
  
  
  
	foreach( $res as $site ) {
  
   $temp = array();
   
   $temp['siteData'] = $site;
   
   $allSites[] = $temp;
  
	}
  
  return $allSites;
	}
	

	
	
}
?>